local events = CreateFrame("Frame")

-- This event gets triggered multiple times, so we validate the playername if we have summoned the same player before
function events:UNIT_SPELLCAST_START(castGUID, spellID)
    if spellID == 698 then -- Ritual of Summoning
        local newSelectedPlayer = GetUnitName("Target")
        if newSelectedPlayer ~= Wokrah["CURRENT_SUMMONING_PLAYER"] then
            local chatType = "PARTY"
            if UnitInRaid("player") then
                chatType = "RAID"
            end

            local zone = GetZoneText()
            local text = "Summoning "..newSelectedPlayer.." to "..zone

            local subZone = GetSubZoneText()
            if subZone and not (subZone == "" or subZone == " ") then
                text = text.." - "..subZone
            end

            local playersInQueue = WokrahReport:GetQueueNum()
            if playersInQueue and playersInQueue > 1 then
                text = text .. ". Player(s) in queue: " .. playersInQueue - 1
            end

            SendChatMessage(text, chatType)
            Wokrah["CURRENT_SUMMONING_PLAYER"] = newSelectedPlayer
        end
    end
end

-- Once the cast has been stopped or finished we clear the CURRENT_SUMMONING_PLAYER var
function events.UNIT_SPELLCAST_CHANNEL_STOP(...)
    local unit, castGUID, spellId = ...

    if (unit == "player" and spellId == 698) then
        Wokrah["CURRENT_SUMMONING_PLAYER"] = nil
    end
end

events:RegisterEvent("UNIT_SPELLCAST_START")
events:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
events:SetScript("OnEvent", function(self, event, ...) self[event](...) end)